/*
  ==============================================================================

  This is an automatically generated file created by the Jucer!

  Creation date:  22 Mar 2012 5:36:09pm

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Jucer version: 1.12

  ------------------------------------------------------------------------------

  The Jucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-6 by Raw Material Software ltd.

  ==============================================================================
*/

//[Headers] You can add your own extra header files here...
//[/Headers]

#include "asciiEditor.h"


//[MiscUserDefs] You can add your own user definitions and misc code here...
//[/MiscUserDefs]

//==============================================================================
asciiEditor::asciiEditor ()
    : textEditor (0)
{
    addAndMakeVisible (textEditor = new TextEditor (T("new text editor")));
    textEditor->setMultiLine (true);
    textEditor->setReturnKeyStartsNewLine (true);
    textEditor->setReadOnly (false);
    textEditor->setScrollbarsShown (true);
    textEditor->setCaretVisible (true);
    textEditor->setPopupMenuEnabled (true);
    textEditor->setText (String::empty);


    //[UserPreSize]
    //[/UserPreSize]

    setSize (300, 168);

    //[Constructor] You can add your own custom stuff here..
    dataLenght = 0;// _DATA_BUFFER_LENGTH_;

    //[/Constructor]
}

asciiEditor::~asciiEditor()
{
    //[Destructor_pre]. You can add your own custom destruction code here..
    //[/Destructor_pre]

    deleteAndZero (textEditor);

    //[Destructor]. You can add your own custom destruction code here..
    //[/Destructor]
}

//==============================================================================
void asciiEditor::paint (Graphics& g)
{
    //[UserPrePaint] Add your own custom painting code here..
    //[/UserPrePaint]

    g.fillAll (Colours::white);

    //[UserPaint] Add your own custom painting code here..
    //[/UserPaint]
}

void asciiEditor::resized()
{
    textEditor->setBounds (4, 4, 292, 160);
    //[UserResized] Add your own custom resize handling here..
    //[/UserResized]
}



//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...
int asciiEditor::getDataBuffer(char* dataBuffer){
	updateDataBuffer();
	memcpy (dataBuffer,this->dataBuffer,dataLenght);
	return dataLenght;
}

int asciiEditor::getDataLength(){
	return dataLenght;
}

void asciiEditor::setDataBuffer(char* dataBuffer, unsigned int length, bool backToTop){

	//TODO. HAY QUE LIMITAR EL TAMAO DE LOS BUFFERES QUE SE CARGAN PARA EVITAR DESBORDAMIENTOS.
	if (length>_ASCII_BUFFER_LENGTH_){
		length = _ASCII_BUFFER_LENGTH_;
	}

	//Actualizamos el buffer interno y su longitud.
	memcpy(this->dataBuffer, dataBuffer, length);
	dataLenght = length;

	//Actualizamos el editor de texto asociado.
	String aux1(dataBuffer,length);
	String aux2 = "";
	char c;

	for (unsigned int i=0; i<length; i++){
		c = aux1.toCString()[i];

		if (c == '\r'){ aux2 += "\\r";  continue; }
		if (c == '\n'){ aux2 += "\\n\n";  continue; }
		if (c == '\t'){ aux2 += "\\t";  continue; }
		if (c == '\\'){ aux2 += "\\\\"; continue; }
		if (c == '\b'){ aux2 += "\\b";  continue; }
		if (c == '\f'){ aux2 += "\\f";  continue; }

		//A los caracteres no visibles no se les da representacin. // TODO. TERMINAR ESTO Y BUSCAR POR QUE A VECES SALE UN CERO.
		if (c>=32 && c<=128){
			aux2 += aux1.toCString()[i];
		}else{
			break;
		}
	}

	//aux = aux.replace(String( (char*)"\r"), "\\r", false);
	//aux = aux.replace(String (CharPointer_UTF8 ("\n")), "\\n", false);
	textEditor->setText(aux2);
}

void asciiEditor::cleanDataBuffer(){
	for (unsigned int i=0; i<_ASCII_BUFFER_LENGTH_; i++){
		this->dataBuffer[i]=0;
	}

	dataLenght = 0;

	textEditor->setText("");
}

void asciiEditor::updateDataBuffer(){
	//Reemplazamos todos los caracteres especiales.
	String aux1 = textEditor->getText();
	String aux2 = "";
	char c, lastChar;
	lastChar=0;

	//Si no hay caracteres en el editor de texto, hay que borrar el buffer entero.
//	if (aux1.length()==0){
//		memset(dataBuffer,'\0',dataLenght);
//		dataLenght = 0;
//		return;
//	}

	for (unsigned int i=0; i<aux1.length(); i++){

		char c = aux1.toCString()[i];

		if (c=='\\'){
			if (lastChar!='\\'){
				lastChar = c;
				continue;
			}
		}

		if (lastChar=='\\'){
			if (c=='\\'){ aux2 += '\\';}
			if (c=='r') { aux2 += '\r';}
			if (c=='n') { aux2 += '\n';}
			if (c=='t') { aux2 += '\t';}
			if (c=='b') { aux2 += '\b';}
			if (c=='f') { aux2 += '\f';}

			lastChar = 0;
			continue;
		}

		//Los caracteres no imprimibles no se incluyen.
		if (!(c>=32 && c<=128)){
			continue;
		}

		aux2 += c;
		lastChar = c;
	}

	dataLenght = aux2.length();
	memcpy(dataBuffer,aux2.toCString(),dataLenght);

}

void asciiEditor::setEditable(bool state){
	textEditor->setReadOnly(!state);
}

//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Jucer information section --

    This is where the Jucer puts all of its metadata, so don't change anything in here!

BEGIN_JUCER_METADATA

<JUCER_COMPONENT documentType="Component" className="asciiEditor" componentName=""
                 parentClasses="public Component" constructorParams="" variableInitialisers=""
                 snapPixels="4" snapActive="1" snapShown="1" overlayOpacity="0.330000013"
                 fixedSize="1" initialWidth="300" initialHeight="168">
  <BACKGROUND backgroundColour="ffffffff"/>
  <TEXTEDITOR name="new text editor" id="11639d8fb7e5aabf" memberName="textEditor"
              virtualName="" explicitFocusOrder="0" pos="4 4 292 160" initialText=""
              multiline="1" retKeyStartsLine="1" readonly="0" scrollbars="1"
              caret="1" popupmenu="1"/>
</JUCER_COMPONENT>

END_JUCER_METADATA
*/
#endif
